# coding: utf-8

"""
    VRt.Agro [AG]

    The version of the OpenAPI document: 6.8.2055

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist, constr
from vrt_lss_agro.models.capacity_forecast_element import CapacityForecastElement
from vrt_lss_agro.models.price_forecast_element import PriceForecastElement

class Pricelist(BaseModel):
    """
    Price forecast for a particular crop. 
    """
    crop_key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Target key.")
    price_forecast: conlist(PriceForecastElement, max_items=3653, min_items=0) = Field(..., description="Prices tied to the dates at which the market uys\\sells the specified crop.")
    capacity_forecast: Optional[conlist(CapacityForecastElement, max_items=3653, min_items=0)] = Field(None, description="Capacity forecast.")
    __properties = ["crop_key", "price_forecast", "capacity_forecast"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Pricelist:
        """Create an instance of Pricelist from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in price_forecast (list)
        _items = []
        if self.price_forecast:
            for _item in self.price_forecast:
                if _item:
                    _items.append(_item.to_dict())
            _dict['price_forecast'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in capacity_forecast (list)
        _items = []
        if self.capacity_forecast:
            for _item in self.capacity_forecast:
                if _item:
                    _items.append(_item.to_dict())
            _dict['capacity_forecast'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Pricelist:
        """Create an instance of Pricelist from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Pricelist.parse_obj(obj)

        _obj = Pricelist.parse_obj({
            "crop_key": obj.get("crop_key"),
            "price_forecast": [PriceForecastElement.from_dict(_item) for _item in obj.get("price_forecast")] if obj.get("price_forecast") is not None else None,
            "capacity_forecast": [CapacityForecastElement.from_dict(_item) for _item in obj.get("capacity_forecast")] if obj.get("capacity_forecast") is not None else None
        })
        return _obj

